﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class ctlAppointment : UserControl
    {
        public ctlAppointment()
        {
            InitializeComponent();
        }

        public void add_appointment(DateTime dt_time, Control ctl)
        {
            DateTime dt_out;
            int int_minute = 0;
            int int_row = 0;
            int int_col = 0;

            /* Типа округления */
            if (dt_time.Minute == 0) int_minute = 0;
            else if (dt_time.Minute >= 0 && dt_time.Minute < 15) int_minute = 0;  // Есди между 0..15 минут, то 0 минут
            else if (dt_time.Minute >= 15 && dt_time.Minute < 30) int_minute = 15; // Есди между 15..30 минут, то 15 минут
            else if (dt_time.Minute >= 30 && dt_time.Minute < 45) int_minute = 30; // Есди между 30..45 минут, то 30 минут
            else if (dt_time.Minute >= 45 && dt_time.Minute < 59) int_minute = 45; // Есди между 45..59 минут, то 45 минут

            /* Вычисляем день недели */
            if (dt_time.DayOfWeek == DayOfWeek.Monday)
                int_col = 1;    // Понедельник
            else if (dt_time.DayOfWeek == DayOfWeek.Tuesday)
                int_col = 2;    // Вторник
            else if (dt_time.DayOfWeek == DayOfWeek.Wednesday)
                int_col = 3;    // Среда
            else if (dt_time.DayOfWeek == DayOfWeek.Thursday)
                int_col = 4;    // Четверг
            else if (dt_time.DayOfWeek == DayOfWeek.Friday)
                int_col = 5;    // Пятница
            else if (dt_time.DayOfWeek == DayOfWeek.Saturday)
                int_col = 6;    // Суббота
            if (dt_time.DayOfWeek == DayOfWeek.Sunday)
                int_col = 7;    // Воскресенье

            /* Итерация всех дочерних элементов в таблице */
            foreach (Control c in this.tblAppointment.Controls) 
            {
                /* Если это время, и */
                if (DateTime.TryParse(c.Text, out dt_out) && dt_out != null && dt_out.Hour == dt_time.Hour && dt_out.Minute == int_minute)
                {
                    TableLayoutPanel t = (TableLayoutPanel)c.Parent;    // Получаем родительский элемент
                    int_row = t.GetRow(c);                              // Находим строку по объекту
                    tblAppointment.Controls.Add(ctl, int_col, int_row); // Добавляем элемент
                }
            }
        }
    }
}
